/* mbed simple H-bridge motor controller
* Copyright (c) 2007-2010, sford, http://mbed.org
*
* Permission is hereby granted, free of charge, to any person obtaining a copy
* of this software and associated documentation files (the "Software"), to deal
* in the Software without restriction, including without limitation the rights
* to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
* copies of the Software, and to permit persons to whom the Software is
* furnished to do so, subject to the following conditions:
*
* The above copyright notice and this permission notice shall be included in
* all copies or substantial portions of the Software.
*
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
* IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
* AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
* LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
* OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
* THE SOFTWARE.
*/

#include "Motor.h"
#include "mbed.h"

Motor::Motor(PinName pwm, PinName fwd, PinName rev, PinName stby) :
_pwm(pwm), _fwd(fwd), _rev(rev), _stdby(stby)//, speedControl(K, Ti, Td, itv)//, encoder(CH_A, CH_B, NC, pPerRev)
{

    // Set initial condition of PWM
    _pwm.period_us(40);
    _stdby = 1;
    // Initial condition of output enables
    _fwd = 0;
    _rev = 0;

    //PID config
    //speedControl.setInputLimits(0, 1);
    //speedControl.setOutputLimits(0, 1);
    //speedControl.setMode(AUTO); 

}

void Motor::speed(float speed) {

/*PID do enkoderow i utrzymywania stalej predkosci*/
/*
    if (speed != set_speed){
        speedControl.setSetPoint(speed);
        set_speed = speed;
    }

    pulses = encoder.getPulses();
    curr_speed = (pulses-prev_pulses) / max_pulse_rate;
    prev_pulses = pulses;

    speedControl.setProcessValue(curr_speed);
    speed = speedControl.compute();
*/

    _fwd = (speed > 0.0);
    _rev = (speed < 0.0);
    _pwm = abs(speed);
}
